%!TEX root = ../main.tex

\chapter{Source Code and Schemas} \label{a:sourcecode}

\section{JSON Schema to validate Tree}

\begin{lstlisting}[language=json, caption={A JSON schema as per the \cite{json_schema} draft used to validate the Tree-JSON}, label=lst:jsocnschema, breaklines=true]
{
  "$schema": "http://json-schema.org/draft-07/schema#",
  "type": "object",
  "properties": {
    "nodes": {
      "type": "object",
      "additionalProperties": {
        "$ref": "#/definitions/node"
      }
    },
    "edges": {
      "type": "object",
      "additionalProperties": {
        "$ref": "#/definitions/edge"
      }
    },
    "start_node": {
      "type": "string",
      "pattern": "^[a-zA-Z0-9-_]+$",
      "description": "The id of the start node"
    }
  },
  "required": [
    "nodes",
    "edges"
  ],
  "definitions": {
    "node": {
      "type": "object",
      "properties": {
        "ar_features": {
          "type": "array",
          "items": {
            "$ref": "#/definitions/ar_feature"
          },
          "additionalItems": false,
          "uniqueItems": true
        },
        "description": {
          "type": "string",
          "description": "The node's description, to be displayed on the graph"
        },
        "long_description": {
          "type": "string",
          "description": "The node's long description, to be shown in the tooltip"
        },
        "images_dir": {
          "type": [
            "string",
            "null"
          ],
          "description": "The directory where the images are stored"
        }
      },
      "required": [
        "description",
        "long_description"
      ],
      "additionalProperties": false
    },
    "edge": {
      "type": "object",
      "properties": {
        "source": {
          "type": "string",
          "pattern": "^[a-zA-Z0-9-_]+$",
          "description": "The source node's unique identifier"
        },
        "target": {
          "type": "string",
          "pattern": "^[a-zA-Z0-9-_]+$",
          "description": "The target node's unique identifier"
        },
        "type": {
          "type": "string",
          "description": "The node's type",
          "enum": [
            "continue",
            "option"
          ]
        },
        "description": {
          "type": "string",
          "description": "The edge's description, to be displayed on the graph"
        },
        "long_description": {
          "type": "string",
          "description": "The edge's long description, to be shown in the tooltip"
        }
      },
      "required": [
        "source",
        "target",
        "type",
        "description",
        "long_description"
      ],
      "additionalProperties": false
    },
    "ar_feature": {
      "type": "object",
      "properties": {
        "cad_part": {
          "type": "string",
          "description": "The CAD part of the AR feature"
        },
        "indicators": {
          "type": "array",
          "items": {
            "type": "object",
            "properties": {
              "type": {
                "type": "string",
                "description": "The type of the indicator"
              },
              "position": {
                "type": "object",
                "properties": {
                  "x": {
                    "type": "number",
                    "description": "The x position of the indicator"
                  },
                  "y": {
                    "type": "number",
                    "description": "The y position of the indicator"
                  }
                },
                "required": [
                  "x",
                  "y"
                ]
              }
            },
            "required": [
              "type",
              "position"
            ],
            "additionalProperties": false
          },
          "additionalItems": false
        }
      },
      "required": [
        "cad_part",
        "indicators"
      ],
      "additionalProperties": false,
      "uniqueItems": true
    }
  }
}
\end{lstlisting}

